<template>
    <div v-if="!isLoaded" class="main-page">
        <div class="block-main">
            <div class="title-block">Новинки фильмотеки</div>
            <slider-film :list="newFilms"></slider-film>
        </div>

        <div class="all-films-tags tags">
            <router-link v-for="genre in FilmsGenres" :key="genre.id" :to="{name: 'FilmsIndex', params: {genreFilter: genre}}" >{{genre.title}}</router-link>
        </div>

        <div class="block-main favorites-channels">
            <div class="title-block">Избранные каналы</div>
            <div class="body-block">
                <div class="channels-list list" v-if="favoritesChannels.length > 0">
                    <router-link  v-for="(chanel, i) in favoritesChannels"  :to="{name: 'ChannelsView', params: {id: chanel.id, index: i}}" class="channel">
                        <div class="img-h pull-left"> <img :src="$store.state.host + chanel.logo" alt=""></div>
                        <div class="title"> {{chanel.name}} </div>
                    </router-link>
                </div>
                <div v-else class="empty">
                    Список избранных каналов пуст
                </div>
            </div>
        </div>

        <div class="block-main favorites-channels">
            <div class="title-block">Избранные фильмы</div>
            <div class="body-block">
                <div class="films-list" v-if="filmsFavorite.length > 0">
                    <router-link  v-for="(film, i) in filmsFavorite" :to="{name: 'FilmsView', params: {id: film.id, index: i}}" class="film">
                        <div class="img-h pull-left">
                            <img :src="$store.state.host + film.cover" alt="" />
                        </div>
                        <div class="now-playing">
                            <div class="title">{{film.name}}</div>
                            <div class="genres"><span class="title">Жанр:</span> {{film.genres}}</div>
                            <div class="year"><span class="title">Год:</span> {{film.year}}</div>
                            <div class="director"><span class="title">Режисер:</span> {{film.director}}</div>
                            <div class="actors"><span class="title">Актеры:</span> {{film.actors}}</div>
                        </div>
                    </router-link>
                </div>
                <div v-else class="empty">
                    Список избранных каналов пуст
                </div>
            </div>
        </div>
    </div>
    <div v-else class="loading-container"><div class="loading-box"></div></div>
</template>

<script>
    import sliderFilm from '@/components/slider'
    import { store } from '../main';

    export default {
        name: "index",
        components: {
            sliderFilm
        },
        computed: {
            isLoaded() {
                return this.$store.getters.isLoading('mainPage') ? this.$store.getters.isLoading('mainPage') : false;
            },
            channels() {
                return this.$store.getters.getChannels
            },
            favoritesChannels() {
                return this.$store.getters.getChannelsFavorite
            },
            films() {
                return this.$store.state.filmsLast.filter(element => !!element.id );
            },
            filmsFavorite() {
                return this.$store.getters.getFilmsFavorite ? this.$store.getters.getFilmsFavorite : []
            },
            filterFilms: function () {
                return this.films.filter((film) => {
                    return film.genres.match( 'Все' )
                });
            },
            newFilms() {
                return this.films.splice(0,20)
            },
            favoritesFilms() {
                return this.films.filter(film => film.favorite === 1 && film.genres !== 'Address_1');
            },

            FilmsGenres () {
                return this.$store.getters.getFilmGenres
            },
            // FilmsGenres () {
            //     return this.$store.getters.getFilmsGenres
            // },
            // FilmsCategory () {
            //     return this.$store.getters.getFilmsCategory
            // },
            // ChannelsGenres () {
            //     return this.$store.getters.getChannelsGenres
            // },
        },
        mounted() {
            if (!store.state.mainPageInfoLoad || store.state.films_last_ids.length <= 0) {
                store.dispatch('loadMainPage');
            }
        },
    }
</script>

<style scoped>
    .block-main {
        margin-bottom: 25px;

    }
    .block-main:last-child {
        margin-bottom: 0;
    }
    .block-main .title-block {
        font-family: Gil-SB, serif;
        font-size: 28px;
        display: inline-flex;
        align-items: center;
        line-height: 35px;
        margin-bottom: 5px;
    }
    .block-main .body-block {
        padding: 15px 20px;
        background: #fff;
    }

    .list-category {
        display: flex;
        flex-wrap: wrap;
    }
    .list-category a {
        display: block;
        width: calc(25% - 10px);
        margin: 5px 5px;
        padding: 15px 20px;
        box-shadow: 0 0 3px rgba(0,0,0,.25);
        text-align: center;
    }

    @media (max-width: 1000px) {
        .list-category a {
            width: calc(100%/3 - 10px);
        }
    }
    @media (max-width: 760px) {
        .list-category a {
            width: calc(100%/2 - 10px);
        }
    }
    @media (max-width: 450px) {
        .list-category a {
            width: calc(100% - 10px);
        }
    }

    .tags a{
        -webkit-animation-name: coloring, tagmove;
        -webkit-animation-timing-function: cubic-bezier(.50, 0, .50, 1);
        -webkit-animation-iteration-count: infinite;

        -moz-animation-name: coloring, tagmove;
        -moz-animation-timing-function: cubic-bezier(.50, 0, .50, 1);
        -moz-animation-iteration-count: infinite;

        animation-name: coloring, tagmove;
        animation-timing-function: cubic-bezier(.50, 0, .50, 1);
        animation-iteration-count: infinite;
        position:relative;
        opacity:0;
        padding: 5px 10px;
    }

    .tags a:nth-child(1)  { color:#ffd !important; animation-delay:1s; animation-duration:9.59s; }
    .tags a:nth-child(2)  { color:#fed !important; animation-delay:4s; animation-duration:8.35s; }
    .tags a:nth-child(3)  { color:#fdf !important; animation-delay:3s; animation-duration:7.17s; }
    .tags a:nth-child(4)  { color:#ffe !important; animation-delay:2s; animation-duration:6.26s; }
    .tags a:nth-child(5)  { color:#fdf !important; animation-delay:5s; animation-duration:8.88s; }
    .tags a:nth-child(6) { color:#ffc !important; animation-delay:3s; animation-duration:7.47s; }
    .tags a:nth-child(7) { color:#fff !important; animation-delay:2s; animation-duration:9.79s; }
    .tags a:nth-child(8) { color:#fde !important; animation-delay:4s; animation-duration:5.25s; }
    .tags a:nth-child(9) { color:#fdf !important; animation-delay:6s; animation-duration:7.67s; }
    .tags a:nth-child(10) { color:#ffd !important; animation-delay:3s; animation-duration:6.26s; }
    .tags a:nth-child(11) { color:#ffc !important; animation-delay:4s; animation-duration:8.88s; }
    .tags a:nth-child(12) { color:#fcc !important; animation-delay:2s; animation-duration:7.35s; }
    .tags a:nth-child(13) { color:#fef !important; animation-delay:5s; animation-duration:9.79s; }
    .tags a:nth-child(14) { color:#ffd !important; animation-delay:1s; animation-duration:8.25s; }
    .tags a:nth-child(15) { color:#fdd !important; animation-delay:4s; animation-duration:7.17s; }
    .tags a:nth-child(16) { color:#fff !important; animation-delay:1s; animation-duration:6.26s; }
    .tags a:nth-child(17) { color:#fcd !important; animation-delay:3s; animation-duration:8.58s; }
    .tags a:nth-child(18) { color:#fff !important; animation-delay:2s; animation-duration:7.27s; }
    .tags a:nth-child(19) { color:#fef !important; animation-delay:1s; animation-duration:9.09s; }
    .tags a:nth-child(20) { color:#ffd !important; animation-delay:6s; animation-duration:9.45s; }
    .tags a:nth-child(21) { color:#ffd !important; animation-delay:4s; animation-duration:6.45s; }
    .tags a:nth-child(22) { color:#ffd !important; animation-delay:3s; animation-duration:4.45s; }
    .tags a:nth-child(23) { color:#ffd !important; animation-delay:2s; animation-duration:3.45s; }
    .tags a:nth-child(24) { color:#ffd !important; animation-delay:5s; animation-duration:2.45s; }
    .tags a:nth-child(25) { color:#ffd !important; animation-delay:6s; animation-duration:5.45s; }
    .tags a:nth-child(26) { color:#ffd !important; animation-delay:3s; animation-duration:6.56s; }
    .tags a:nth-child(27) { color:#ffd !important; animation-delay:4s; animation-duration:3.65s; }
    .tags a:nth-child(28) { color:#ffd !important; animation-delay:1s; animation-duration:4.36s; }
    .tags a:nth-child(29) { color:#ffd !important; animation-delay:6s; animation-duration:1.43s; }
    .tags a:nth-child(30) { color:#ffd !important; animation-delay:2s; animation-duration:6.61s; }

    .tags a:hover { color:#fff !important; text-decoration:underline !important; }


    .light .tags a { color:#478dcd  !important;}

    .light .tags a:hover { color:#478dcd !important; text-decoration:underline !important; }

    .tags{
        overflow: hidden;
        height: 200px;
        padding-top: 100px;
        font-size: 1.5em !important;
        line-height: 3px;
        margin: 40px auto 50px;
        display: flex;
        flex-wrap: wrap;
        justify-content: space-around;
    }
    .sidebar-tags dt{ display:none; }
    .tags .comma{ display:none; }

    @keyframes tagmove
    {
        from { top:-80px; }
        to { top:80px; }
    }
    @keyframes coloring {
        from { opacity: 0; }
        50% { opacity: 1; }
        to { opacity: 0; }
    }

    @-moz-keyframes tagmove
    {
        from { top:-80px; }
        to { top:80px; }
    }
    @-moz-keyframes coloring {
        from { opacity: 0; }
        50% { opacity: 1; }
        to { opacity: 0; }
    }

    @-webkit-keyframes tagmove
    {
        from { top:-80px; }
        to { top:80px; }
    }
    @-webkit-keyframes coloring {
        from { opacity: 0; }
        50% { opacity: 1; }
        to { opacity: 0; }
    }

</style>
